long FAR PASCAL ClockBarWndProc(hwnd, msg, wParam, lParam)
HWND hwnd;                  /* FILENAME: CLCKPROC.C */
unsigned msg;
WORD wParam;
LONG lParam;
{
    PAINTSTRUCT ps;
    HBRUSH hOldBrush;
    RECT rc, rcClockBar;

    switch (msg)
    {
       case WM_CREATE:
           if(hOldCursor != hAppCursor)
             hOldCursor = SetCursor(hAppCursor);
           strcpy(szCurTime, "HH:MM:SS");
           return(DefWindowProc(hwnd, msg, wParam, lParam));
           break;

       case WM_PAINT:
           BeginPaint(hwnd, &ps);
           SetBkColor(ps.hdc, RGB(255, 255, 255));
           SetTextColor(ps.hdc, RGB(0, 0, 0));
           GetClientRect(hwndClient, &rc);
           MoveWindow(hwnd,
                        rc.right - 71,
                        rc.bottom - GetSystemMetrics(SM_CYMENU),
                        71,
                        GetSystemMetrics(SM_CYMENU),
                        TRUE);
           hOldBrush=SelectObject(ps.hdc, GetStockObject(WHITE_BRUSH));
           GetClientRect(hwndClockBar, &rcClockBar);
           DrawText(ps.hdc, (LPSTR)szCurTime, -1, &rcClockBar,
                      DT_SINGLELINE | DT_CENTER);
           SelectObject(ps.hdc, hOldBrush);
           EndPaint(hwnd, &ps);
           return(TRUE);
           break;

      case WM_TIMER:
           if(wParam==1)
             {
               struct dostime_t Time;
               char             Hr[3], Mn[3], Se[3];

               _dos_gettime(&Time);
               if(Time.hour<10)
                 wsprintf((LPSTR)Hr, "0%d", Time.hour);
               else
                 wsprintf((LPSTR)Hr, "%d", Time.hour);
               if(Time.minute<10)
                 wsprintf((LPSTR)Mn, "0%d", Time.minute);
               else
                 wsprintf((LPSTR)Mn, "%d", Time.minute);
               if(Time.second<10)
                 wsprintf((LPSTR)Se, "0%d", Time.second);
               else
                 wsprintf((LPSTR)Se, "%d", Time.second);
               wsprintf((LPSTR)szCurTime, (LPSTR)"%s:%s:%s",
                        (LPSTR)Hr, (LPSTR)Mn, (LPSTR)Se);

               InvalidateRect(hwndClockBar, NULL, TRUE);
               UpdateWindow(hwndClockBar);
                            return(TRUE);
               break;
             }
      default:
           return(DefWindowProc(hwnd, msg, wParam, lParam));
           break;
    }
  return(0L);
}
