BOOL PrintPRfile(hPrDC, FileName);         /* FILENAME: PRPRFILE.C */
HDC hPrDC;
LPSTR FileName;
{
    TEXTMETRIC tm;
    FILE *File;
    char PrintLine[255];
    int PageSize, LineSpace, LinesPerPage,
        LineLength, CurrentLine, nStatus;

    GetTextMetrics(hPrDC, &tm);
    LineSpace = tm.tmHeight + tm.tmExternalLeading;
    PageSize = GetDeviceCaps(hPrDC, VERTRES);
    LinesPerPage = PageSize / LineSpace - 1;

    if(!(File = fopen(FileName. "r"))
        return(FALSE);
    LineCount = 1;
    while (!feof(File))
    {
        fgets(PrintLine, sizeof(PrintLine), File);
        TextOut(hPrDC, 0, CurrentLine*LineSpace,
                      (LPSTR)PrintLine, strlen(PrintLine));
        if(++CurrentLine > LinesPerPage)
        {
            CurrentLine = 1;
            nStatus = Escape(hPrDC, NEWFRAME, 0, 0L, 0L);
            if(nStatus < 0 || bAbort)
                break;
            if(nStatus > =  0 && !bAbort)
            {
                Escape(hPrDC, NEWFRAME, 0, 0L, 0L);
                Escape(hPrDC, ENDDOC,   0, 0L, 0L);
            }
        }
    }

  fclose(FileName);
  return(TRUE);
}
