long FAR PASCAL MessageBarWndProc(hwnd, msg, wParam, lParam)
HWND hwnd;                         /* FILENAME: MSGPROC.C */
unsigned msg;
WORD wParam;
LONG lParam;
{
    PAINTSTRUCT ps;
    HBRUSH hBrush, hOldBrush;
    RECT rc, rcMsgBar;

    switch (msg)
    {
      case WM_CREATE:
           if(hOldCursor != hAppCursor)
             hOldCursor = SetCursor(hAppCursor);
           strset(szBlank, 32);
           return(TRUE);
           break;

      case WM_PAINT:
          BeginPaint(hwndMsgBar, &ps);
          SetBkColor(ps.hdc, RGB(255, 0, 0));
          SetTextColor(ps.hdc, RGB(255, 255, 255));
          GetClientRect(hwndClient, &rc);
          SetWindowPos(hwndMsgBar, NULL,
                          rc.left,
                          rc.bottom-GetSystemMetrics(SM_CYMENU),
                          rc.left+rc.right-71,
                          GetSystemMetrics(SM_CYMENU),
                          SWP_NOZORDER);
          GetClientRect(hwndMsgBar, &rcMsgBar);
          hBrush=CreateSolidBrush(RGB(255, 0, 0));
          hOldBrush=SelectObject(ps.hdc, hBrush);
          FillRect(ps.hdc, &rcMsgBar, hBrush);
          SetRect(&rcMsgBar,
                     rcMsgBar.left+4,
                     rcMsgBar.top,
                     rcMsgBar.right,
                     rcMsgBar.bottom);
          DrawText(ps.hdc, (LPSTR)szMsg, -1, &rcMsgBar,
                      DT_SINGLELINE | DT_LEFT);
          SelectObject(ps.hdc, hOldBrush);
          DeleteObject(hBrush);
          strcpy(szOldMsg, szMsg);
          EndPaint(hwndMsgBar, &ps);
          return(TRUE);
          break;

      default:
           return(DefWindowProc(hwnd, msg, wParam, lParam));
           break;
    }
  return(0L);
}
